/*
 * littleCPUID
 * 05.09.14 : Makoto NARA (Mc.N)
 */

/*
 * Copyright (c) 2005 Makoto NARA (Mc.N) All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY Makoto NARA (Mc.N) ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#if !defined(AFX_LITTLECPUIDDLG_H__20A6190C_C876_426C_8BBD_6117EDC83E2D__INCLUDED_)
#define AFX_LITTLECPUIDDLG_H__20A6190C_C876_426C_8BBD_6117EDC83E2D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CLittleCPUIDDlg _CAO

class CLittleCPUIDDlg : public CDialog
{
// \z
public:
	CLittleCPUIDDlg(CWnd* pParent = NULL);	// W̃RXgN^

// _CAO f[^
	//{{AFX_DATA(CLittleCPUIDDlg)
	enum { IDD = IDD_LITTLECPUID_DIALOG };
	CButton	m_btn_retry;
	CButton	m_btn_save;
	CButton	m_btn_load;
	CButton	m_btn_3dnowext;
	CButton	m_btn_3dnow;
	CButton	m_btn_psn;
	CButton	m_btn_msr;
	CEdit	m_ctl_infor;
	CButton	m_btn_synchack;
	CButton	m_btn_sse3;
	CButton	m_btn_sse2;
	CButton	m_btn_sse;
	CButton	m_btn_register;
	CButton	m_btn_nx;
	CButton	m_btn_mtrr;
	CButton	m_btn_mmx;
	CButton	m_btn_ht;
	CButton	m_btn_est;
	CButton	m_btn_amd64;
	CComboBox	m_cmb_processor;
	CString	m_edit_infor;
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CLittleCPUIDDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

private:
	PCPUID_INFOR pcpu;
	void initProcessor(void);
	void refreshProcessor(DWORD iP=0);
	void dispMultiprocessor(DWORD iP);
	void disableProcessor(void);
	void dispFlagInfo(DWORD feature);

// Cve[V
protected:
	HICON m_hIcon;
	HICON m_hIconMini;

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CLittleCPUIDDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonMmx();
	afx_msg void OnButtonSse();
	afx_msg void OnButtonSse2();
	afx_msg void OnButtonSse3();
	afx_msg void OnButtonPsn();
	afx_msg void OnButtonMtrr();
	afx_msg void OnButtonAmd64();
	afx_msg void OnButtonNx();
	afx_msg void OnButtonEst();
	afx_msg void OnButtonHt();
	afx_msg void OnSelchangeComboProcessor();
	afx_msg void OnDestroy();
	afx_msg void OnButtonClear();
	afx_msg void OnButtonCopy();
	afx_msg void OnButtonRegister();
	afx_msg void OnButtonMsr();
	afx_msg void OnButton3dnow();
	afx_msg void OnButton3dnowext();
	afx_msg void OnButtonAbout();
	afx_msg void OnButtonSave();
	afx_msg void OnButtonLoad();
	afx_msg void OnButtonRetry();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_LITTLECPUIDDLG_H__20A6190C_C876_426C_8BBD_6117EDC83E2D__INCLUDED_)
